/*	Renegade Scripts.dll
	Example Plugin Code
	Copyright 2007 Whitedragon(MDB), Jonathan Wilson

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/
#include "gmsettingsclass.h"

#define PluginName "GameSpy Support"
#define PluginVersion "1.1"

class Config {
public:
	static std::vector<std::string> ExtraStringList;
	static std::string CustomGameTitle, GameMode,  PlayerTimeMode, GameTitle;
	static bool ShowGameMode, ShowDriverGunner, ShowTeamChanging, UseTotalPlayerTime,
		ShowFriendlyFire, ShowCredits, ShowTimeLeft, ShowPedestal, ShowRotation, NoWOLAppendPlayerCount;
	static int MaxPlayers, ListenPort;
	
};

struct ExampleSettingsStruct : public virtual SettingsLoader {
	ExampleSettingsStruct(const char *ININame) : SettingsLoader(ININame) {
	}
	void Load();

	std::vector<std::string> ExtraStringList;

	std::string CustomGameTitle, GameMode, PlayerTimeMode;
	bool ShowGameMode, ShowDriverGunner, ShowTeamChanging, NoWOLAppendPlayerCount,
		ShowFriendlyFire, ShowCredits, ShowTimeLeft, ShowPedestal, ShowRotation;
	int MaxPlayers, ListenPort;
};

void Plugin_Load();
void Plugin_Unload();

class Plugin_Example_Script : public ScriptImpClass {
	void Created(GameObject *obj);
	void Destroyed(GameObject *obj);
};

DWORD WINAPI Set_Player_Count_Game_Title(LPVOID params);
DWORD WINAPI Do_GameSpy_Heart_Beat(LPVOID params);